diff -ruN vdr-1.5.15/CONTRIBUTORS vdr-1.5.16/CONTRIBUTORS
--- vdr-1.5.15/CONTRIBUTORS	2008-02-16 17:12:21.000000000 +0100
+++ vdr-1.5.16/CONTRIBUTORS	2008-02-24 11:30:49.000000000 +0100
@@ -122,7 +122,7 @@
  for pointing out a possible hangup when reading a broken epg.data file
 
 Paulo Lopes <pmml@netvita.pt>
- for translating OSD texts to the Portugese language
+ for translating OSD texts to the Portuguese language
 
 Markus Lang <pretender@gaze.de> and Ulrich Röder <dynamite@efr-net.de>
  for making DiSEqC support configurable
@@ -186,7 +186,7 @@
  for reporting a bug in handling of Ca parameters with values <= MAXDEVICES, which
  don't indicate an actual encrypted channel
  for implementing setting the "broken link" flag for GOPs at the beginning of a new
- video sequence, which avoids artefacts when cutting
+ video sequence, which avoids artifacts when cutting
  for suggesting to add VDRVERSNUM to config.h
  for fixing a memory leak in cNonBlockingFileReader
  for fixing an uninitialized variable in cDisplayChannel
@@ -899,6 +899,7 @@
  for pointing out that the canonical spelling of codesets is with '-'
  for a hint on using _nl_msg_cat_cntr
  for adding some missing 'const' keywords
+ for pointing out that "%016llX" should be used instead of "%016LX"
 
 Thomas Koch <tom@harhar.net>
  for his support in keeping the Premiere World channels up to date in 'channels.conf'
@@ -1043,6 +1044,7 @@
  for suggesting to limit the length of the recording name in timers created via
  SVDRP in case VDR is run with --vfat, in order to avoid names that are too long
  for Windows
+ for increasing the valid range of the "Subtitle offset" setup option to -100...100
 
 Ralf Klueber <ralf.klueber@vodafone.com>
  for reporting a bug in cutting a recording if there is only a single editing mark
@@ -1060,6 +1062,8 @@
  for adding more error messages and line numbers when reading EPG data and info.vdr
  for fixing handling "more than 3 byte" key sequences in cKbdRemote::ReadKeySequence()
  for suggesting to ignore lines tagged with '#' in the 'info.vdr' file of a recording
+ for reporting a problem with the backslash ('\') in parameters when executing
+ external commands
 
 Alexander Damhuis <ad@phonedation.de>
  for reporting problems when deleting a timer that is currently recording
@@ -1082,7 +1086,7 @@
  for reporting a crash when canceling a newly created timer
  for making 'diseqc.conf' a required file only if Setup.DiSEqC is activated
  for making VDR use the default configuration directory as defined in the CONFDIR
- varable in the Makefile
+ variable in the Makefile
 
 Michael Walle <michael.walle@web.de>
  for reporting a bug in channel switching after Left/Right has been pressed
@@ -1163,6 +1167,8 @@
  to be displayed late in live mode
  for a patch that was used to implement handling of DVB-S2
  for reporting an invalid access in the section handler when ending VDR
+ for pointing out that cDevice::Transferring() doesn't return the right value in the
+ early stage of channel switching
 
 Richard Robson <richard_robson@beeb.net>
  for reporting freezing replay if a timer starts while in Transfer Mode from the
@@ -1350,7 +1356,7 @@
  for reporting a spelling error in 'canceling'
  for adding some 'mkdir -p' to the Makefile's 'install' target
  for reporting some missing braces in remux.c
- for suggesting to modifiy the Makefile to copy and clean up additional libraries
+ for suggesting to modify the Makefile to copy and clean up additional libraries
  a plugin might provide
 
 Marco Schlüßler <marco@lordzodiac.de>
@@ -1449,7 +1455,7 @@
  for fixing selecting the audio track when pressing Ok in the Audio menu
  for implementing handling DVB subtitles
  for fixing the description of DeviceSetAvailableTrack() and cReceiver(), and adding
- an example ~cMyReceiver() in PLUGINS.html (thanks to Marco Schlüßler).
+ an example ~cMyReceiver() in PLUGINS.html
  for fixing checking compatibility mode for old subtitles plugin
  for a patch that was used to implement handling of DVB-S2
  for fixing setting the date in the channel display of the classic and sttng skins,
@@ -1750,6 +1756,7 @@
  for making the "Play" key start replay of the selected recording in the Recordings
  menu
  for adding missing #include <limits.h> to epg.c and menuitems.h
+ for fixing various spelling errors and improving PLUGINS.html
 
 Steffen Beyer <cpunk@reactor.de>
  for fixing setting the colored button help after deleting a recording in case the next
@@ -1884,7 +1891,7 @@
 Enrico Scholz <enrico.scholz@informatik.tu-chemnitz.de>
  for making VDR use use daemon() instead of fork() to run in daemon mode
  for fixing a possible endless loop in a menu with no selectable items if
- Setup.MenuScrollWrap is true (thanks to Enrico Scholz)
+ Setup.MenuScrollWrap is true
 
 Nicolas Huillard <nhuillard@e-dition.fr>
  for translating OSD texts to the French language
@@ -2132,7 +2139,7 @@
 Anssi Hannula <anssi.hannula@gmail.com>
  for a patch that was used to implement processing the "frequency list descriptor"
  for suggesting that cDevice::GetDevice() should prefer any device that's already
- receiving and doesn't require detatching receivers
+ receiving and doesn't require detaching receivers
  for improving handling Transfer Mode devices when selecting a device to receive
  for fixing handling frequencies in NitFilter::Process()
  for making non-primary devices in Transfer mode be also used for recording
@@ -2202,11 +2209,12 @@
  for reporting that cPlugin::Active() was called too often
 
 Peter Pinnau <vdr@unterbrecher.de>
- for reporting that 'uint32_t' requires uncluding stdint.h in font.h on some systems
+ for reporting that 'uint32_t' requires including stdint.h in font.h on some systems
 
 Petri Helin <phelin@googlemail.com>
  for suggesting to avoid budget DVB cards with Common Interface when tuning to an
  FTA channel
+ for reporting a bug in setting the current subtitle track in Transfer-Mode
 
 Oktay Yolgeçen <oktay_73@yahoo.de>
  for translating OSD texts to the Turkish language
@@ -2299,3 +2307,6 @@
 Benedikt Elser <elser@in.tum.de>
  for a patch that was used to add cStatus::TimerChange() to inform plugins about
  changes to the list of timers
+
+Carel Willemse <ca_willemse@planet.nl>
+ for translating OSD texts to the Dutch language
diff -ruN vdr-1.5.15/HISTORY vdr-1.5.16/HISTORY
--- vdr-1.5.15/HISTORY	2008-02-17 15:29:24.000000000 +0100
+++ vdr-1.5.16/HISTORY	2008-02-24 11:29:50.000000000 +0100
@@ -247,10 +247,10 @@
 2000-11-01: Version 0.67
 
 - The EIT information is now gathered in a separate thread.
-- The sytem time can now be synchronized to the time broadcast in the DVB data
+- The system time can now be synchronized to the time broadcast in the DVB data
   stream. This can be enabled in the "Setup" menu by setting "SetSystemTime" to
   1.  Note that this works only if VDR is running under a user ID that has
-  permisson to set the system time.
+  permission to set the system time.
 - The new item "Schedule" in the "Main" menu opens VDR's EPG (thanks to Robert
   Schneider). See the MANUAL file for a detailed description.
 - The new setup parameters MarginStart and MarginStop define how long (in
@@ -640,7 +640,7 @@
 - The new command line option '-E' can be used to define where the EPG data
   shall be written to. This is especially useful if VDR runs in a system
   that turns off the video disk when it is not used, and therefore needs
-  to write the EPG file to a ramdisk (or turn off writing it alltogether).
+  to write the EPG file to a ramdisk (or turn off writing it altogether).
   See 'vdr --help' for details.
 - Making sure the disk is up and running before starting recording (this
   is important for systems that turn off the video disk when it is not used).
@@ -776,7 +776,7 @@
   set to INVERSION_AUTO, which should work with all channels on Astra).
 - Removing unnecessary double quotes from EPG Subtitle in EPGBugfixLevel >=1.
 - EPG info is now updated if the contents changes but the ID remains the same.
-- Fixed handling SVDRP commands whith more than one blank between the command
+- Fixed handling SVDRP commands with more than one blank between the command
   word and the options.
 - The current volume setting is now saved to setup.conf and restored at the
   next program start.
@@ -907,7 +907,7 @@
   in the call to the shutdown command (option '-s') and the recording command
   (option '-r').
 - Improved error handling in the editing process; the resulting file will be
-  deleted if an error occured.
+  deleted if an error occurred.
 - A message is now prompted at the end of the editing process, indicating
   whether the process succeeded or failed.
 - Fixed setting the LastActivity timestamp after a shutdown prompt (thanks to
@@ -1058,7 +1058,7 @@
 - Changed the meaning of the 'Ca' parameter in 'channels.conf'. Each channel can
   now define which decryption method it needs in order to be accessed. The new
   configuration file 'ca.conf' contains the defined values, and the default
-  'channels.conf' has been modifed to contain the new values for 'Premiere World'
+  'channels.conf' has been modified to contain the new values for 'Premiere World'
   and 'ORF'. If you use the default 'channels.conf' and have the conditional
   access hardware to receive encrypted channels, please make sure you copy the
   file 'ca.conf' into your /video directory (or wherever your configuration files
@@ -1369,7 +1369,7 @@
   cPlayer and cControl have been given the functions GetIndex() and GetReplayMode() to
   allow access to the player's status.
 - Added cOsd::OpenRaw() to create a raw OSD (needed for displaying SPUs).
-- Changed the symantics of the Name parameter in cStatus::Recording() and
+- Changed the semantics of the Name parameter in cStatus::Recording() and
   cStatus::Replaying(). It is no longer the full directory name of the recording,
   but rather just the basic name. This has been changed to allow players that can't
   provide a name to simply use a string that describes the player type (like, e.g.,
@@ -1661,7 +1661,7 @@
 - Implemented new keys to directly access the VDR main menu functions "Schedule",
   "Channels", "Timers", "Recordings", "Setup" and "Commands". If your remote
   control provides keys you want to assign these functions to, you can delete
-  your 'remote.cof' file and restart VDR to  go through the key learning procedure
+  your 'remote.conf' file and restart VDR to  go through the key learning procedure
   again in order to assign these new keys. See MANUAL for more information.
 - The new configuration file 'keymacros.conf' can be used to assign macros to
   the color buttons in normal viewing mode, as well as to up to 9 user defined
@@ -1905,7 +1905,7 @@
 - Fixed handling channels in the "Channels" menu in case there are ':@nnn' group
   separators without names (thanks to Guy Roussin for reporting this one).
 - The SVDRP command CHAN now also accepts channel IDs.
-- Increased the timeout until an index file is considerd no longer to be written
+- Increased the timeout until an index file is considered no longer to be written
   (sometimes in time shift with heavy system load the index file was closed too
   early by the replay thread).
 - Implemented "Link Layer" based CAM support, which hopefully will solve the
@@ -2006,7 +2006,7 @@
 - Added some missing cAudio handling calls (thanks to Werner Fink).
 - Replaced the 'for' loops in StripAudioPackets() with memset() calls (thanks to
   Werner Fink).
-- Further increased the timeout until an index file is considerd no longer to be
+- Further increased the timeout until an index file is considered no longer to be
   written.
 - Fixed a crash in case the index file can't be accessed any more during replay
   (thanks to Stefan Huelswitt for reporting this one).
@@ -2068,7 +2068,7 @@
 - Fixed deleting the last recording in the "Recordings" menu, which started pausing
   live video (thanks to Christoph Friederich for reporting this one).
 - Now setting the "broken link" flag for GOPs at the beginning of a new video
-  sequence, which avoids artefacts when cutting (thanks to Stefan Huelswitt).
+  sequence, which avoids artifacts when cutting (thanks to Stefan Huelswitt).
 - Removed the Mute() call from cDvbDevice::StillPicture() (suggested by Andreas
   Schultz).
 - Updated 'channels.conf.terr' for Berlin (thanks to Andreas Brachold).
@@ -2136,7 +2136,7 @@
 - Updated 'channels.conf.terr' for Berlin (thanks to Juri Haberland).
 - Avoiding short display of the "Main" menu when pressing the "Recordings" button
   or the "Back" button during replay.
-- Further increased the timeout until an index file is considerd no longer to be
+- Further increased the timeout until an index file is considered no longer to be
   written.
 - Implemented separate PausePriority and PauseLifetime parameters for the recordings
   created when pausing live video (suggested by Alfred Zastrow).
@@ -2168,7 +2168,7 @@
 - Updated 'channels.conf.cable' (thanks to Stefan Hußfeldt).
 - Fixed reading 'epg.data' for channels with non-zero RID (thanks to Oliver
   Endriss for reporting this one).
-- Fixed EPG bugfix statistics to avoid log entires for undefined channels (thanks
+- Fixed EPG bugfix statistics to avoid log entries for undefined channels (thanks
   to Lars Bläser for reporting this one).
 - No longer waiting inside cIndexFile::CatchUp() to avoid shortly blocking replay
   at the end of a recording.
@@ -2218,7 +2218,7 @@
   Ahrenberg).
 - Completed the Italian OSD texts (thanks to Antonio Ospite).
 - Fixed breaking off replay in case the user hits "Play" or "Pause" too soon after
-  going into "Pause live video" mode (thanks to Karim Afifi for reporting ths one).
+  going into "Pause live video" mode (thanks to Karim Afifi for reporting this one).
 - Some corrections to the Catalanian OSD texts (thanks to Jordi Vilà).
 - Single event timers are now deleted if the recording they are doing is
   deleted before the timer ends.
@@ -2247,7 +2247,7 @@
   Josten).
 - Fixed device handling in the CICAM menu in case a VDR instance was started
   with a specific device using the -D option (thanks to Gerald Raaf for reporting
-  ths one).
+  this one).
 - Initializing the current channel to '1' to avoid a crash in creating a new
   timer in case there is no device in the system that can actually receive any
   channel (thanks to Malcolm Caldwell for reporting this one).
@@ -2448,7 +2448,7 @@
 2003-10-26: Version 1.2.6pre4
 
 - Fixed handling CAM menus in case the CAM connection fails while the menu
-  is being presented (thanks to Thomas v. Keller for reportign this one).
+  is being presented (thanks to Thomas v. Keller for reporting this one).
 - Added missing 'const' to some cChannel member functions (thanks to Torsten
   Herz).
 
@@ -2668,7 +2668,7 @@
   recording exceeds 10 (suggested by Gregoire Favre). Since the UPT error doesn't
   happen on my system, this has not been explicitly tested.
   The "preliminary fix" for the UPT error in VDR/dvbdevice.c has been disabled
-  by default, since it makes channel switching unpleasently slow. If you want
+  by default, since it makes channel switching unpleasantly slow. If you want
   to have that workaround back, you can uncomment the line
   //#define WAIT_FOR_LOCK_AFTER_TUNING 1
   in VDR/dvbdevice.c.
@@ -2815,7 +2815,7 @@
 - Added a hint to PLUGINS.html about how to name a plugin that implements a skin.
 - Completed the Finnish OSD texts (thanks to Rolf Ahrenberg).
 - Single shot timers and events now show the day of week (adopted with some changes
-  from the "elchi" patch, orginally introduced by Oskar Signell). Plugins that use
+  from the "elchi" patch, originally introduced by Oskar Signell). Plugins that use
   cEvent::GetDateString() should note that this function now returns a longer
   string, including the day of week. The new function const char *WeekDayName(time_t t)
   can be called with a time_t value to get the day of week for that time.
@@ -3267,7 +3267,7 @@
 - Skins need to implement the new cSkinDisplayTrack class to display the audio
   track menu.
 - The ST:TNG skin now displays the current audio track description (if any) at the
-  botton left side.
+  bottom left side.
 - The new setup option "DVB/Audio languages" can be used to control which audio
   language shall be selected in case a channel broadcasts in different languages
   (see MANUAL for details).
@@ -3959,7 +3959,7 @@
   (thanks to Holger Brunn).
 - The new function Skins.QueueMessage() can be called from a background thread
   to queue a message for display. See VDR/skins.h for details.
-- The SVDRP command MESG uses the new message queueing facility, so MESG
+- The SVDRP command MESG uses the new message queuing facility, so MESG
   commands may now be executed at any time, and the message will be displayed
   (no more "pending message").
 
@@ -4483,7 +4483,7 @@
 - Fixed a typo in skins.h (thanks to Alexander Rieger).
 - cSkins::QueueMessage() called from a background thread with an empty message
   now clears all messages that have been previously queued by that thread and have
-  not yet beed displayed (thanks to Alexander Rieger).
+  not yet been displayed (thanks to Alexander Rieger).
 - Fixed handling the color button texts when switching from the 'Schedule' menu of
   a channel without EPG info to the 'What's on now' menu (reported by Rolf
   Ahrenberg).
@@ -4736,7 +4736,7 @@
 - Fixed handling VPS timers in case the EPG event hasn't been 'seen' in a while.
 - Fixed calculating the cache size in cUnbufferedFile::Read() (thanks to Artur Skawina).
 - Removed -fPIC from VDR's and libsi's Makefile (suggested by Prakash Punnoor).
-- Modifed the device selection to better handle timer conflicts (reported by
+- Modified the device selection to better handle timer conflicts (reported by
   Christian Wieninger).
 - Avoiding a compiler warning in libsi's TypeLoop::operator[].
 - Now processing the "frequency list descriptor" (based on a patch from Anssi Hannula).
@@ -4827,7 +4827,7 @@
 - Fixed handling client side termination of SVDRP connections (thanks to Frank
   Schmirler).
 - cDevice::GetDevice() now prefers any device that's already receiving and doesn't
-  require detatching receivers (suggested by Anssi Hannula).
+  require detaching receivers (suggested by Anssi Hannula).
 - Fixed handling numeric keys in the channel display after switching channel groups
   (thanks to Andreas Regel).
 - Menu items derived from cMenuEditIntItem now loop though their values if they
@@ -4893,7 +4893,7 @@
 
 - Revoked the change to cDevice::GetDevice() that was introduced in version 1.4.1-2,
   which made it prefer any device that's already receiving and doesn't require
-  detatching receivers. This change has caused some unwanted behavior, so further
+  detaching receivers. This change has caused some unwanted behavior, so further
   testing is necessary.
 
 2006-09-03: Version 1.4.2-1
@@ -5041,7 +5041,7 @@
   decrypting the current channel again.
 - The Setup/CAM menu now dynamically refreshes its items and displays whether
   a CAM is present or ready. The 'Reset' function no longer leaves the menu.
-- The CAM menu will now be openend when pressing the Ok key on a slot entry.
+- The CAM menu will now be opened when pressing the Ok key on a slot entry.
 - The CAM menu now stays within the current menu context and doesn't close and
   reopen the menu every time an option is selected.
 - When an encrypted channel is switched to for the first time, VDR now checks
@@ -5400,7 +5400,7 @@
   texts they want to reuse from VDR's core translations (suggested by Matthias
   Becker).
 - VDR now uses the default configuration directory as defined in the CONFDIR
-  varable in the Makefile (thanks to Thomas Schmidt).
+  variable in the Makefile (thanks to Thomas Schmidt).
 - The SVDRP command LSTC can now list the channels with group separators if the
   option ':groups' is given (thanks to Andreas Mair).
 - Added a missing error report to cCuttingThread::Action() (thanks to Udo
@@ -5479,7 +5479,7 @@
   i18n: $(I18Npot) $(I18Nmo)
   (based on a suggestion by Torsten Kunkel).
 - Removed a duplicate ',' from the ca_ES.po file (thanks to Thomas Günther).
-- Added the 'ß' character to the "allowed charcaters" in the de_DE.po file
+- Added the 'ß' character to the "allowed characters" in the de_DE.po file
   (suggested by Thomas Günther).
 - Made the default copy ctor of cRecording private (thanks to Markus Hahn).
   Same for the assign operator.
@@ -5550,7 +5550,7 @@
 - Added a missing setting of lastFreeMB in cMenuMain::Update() (reported by
   Andreas Brugger).
 - Added '-Wno-parentheses' to the compiler options in order to avoid silly compiler
-  warnings for expessions like 'a || b && c', where GCC 4.3 wants to force the
+  warnings for expressions like 'a || b && c', where GCC 4.3 wants to force the
   programmer to write 'a || (b && c)', while everybody knows that '&&' links
   stronger than '||' (reported by Tobias Grimm).
 - Updated the Hungarian language texts (thanks to István Füley).
@@ -5572,7 +5572,7 @@
 - The new option --localedir can be used to set the locale directory at runtime
   (based on a patch from Stefan Huelswitt).
 - Fixed finding new transponders (thanks to Winfried Köhler).
-- Implemented handling of DVB-S2 (thanks to Marco Schlüßler and Reinhald Nissl
+- Implemented handling of DVB-S2 (thanks to Marco Schlüßler and Reinhard Nissl
   for a patch that was used to implement this). VDR now requires the "multiproto"
   DVB driver, e.g. from http://jusst.de/hg/multiproto.
 - Removed switching to the next higher or lower channel if the current channel
@@ -5643,3 +5643,30 @@
 - Introduced 'operator const void * ()' in cString to catch cases where operator*()
   should be used.
 - Fixed calculating the scrollbar sizes in the skins.
+
+2008-02-24: Version 1.5.16
+
+- Fixed setting the current subtitle track in Transfer-Mode (reported by Petri Helin,
+  thanks to Reinhard Nissl for pointing out that cDevice::Transferring() doesn't
+  return the right value in the early stage of channel switching).
+- Updated the Danish OSD texts (thanks to Mogens Elneff).
+- Updated the Dutch OSD texts (thanks to Carel Willemse).
+- Fixed various spelling errors and improved PLUGINS.html (thanks to Ville Skyttä).
+- Updated the Italian OSD texts (thanks to Diego Pierotto).
+- Fixed the format in cRemote::Put() to use "%016llX" instead of "%016LX" (thanks
+  to Ludwig Nussel for pointing this out).
+- Revised the fix of calculating the scrollbar height in the skins. The scrollbar
+  handle now always has a height that is at least the width of the scrollbar.
+- When switching the device that's used for live viewing away from the current
+  transponder in favor of an upcoming recording, an attempt is now made to stay
+  on the current channel by possibly going into 'Transfer Mode'.
+- The CAM menu now stays open as long as it is automatically updated, even without
+  pressing a remote control key. This is important when updating the CAM firmware
+  from the transponder.
+- No longer trying to switch to an available channel if the primary device has
+  no valid programme and a menu is open (avoids interference with the CAM in
+  case a CAM menu is open).
+- Increased the valid range of the "Subtitle offset" setup option to -100...100
+  (thanks to Rolf Ahrenberg).
+- Added the backslash ('\') to the list of characters that need to be escaped
+  when executing external commands (thanks to Peter Bieringer for reporting this one).
diff -ruN vdr-1.5.15/MANUAL vdr-1.5.16/MANUAL
--- vdr-1.5.15/MANUAL	2008-02-10 15:23:48.000000000 +0100
+++ vdr-1.5.16/MANUAL	2008-02-24 11:09:17.000000000 +0100
@@ -691,8 +691,8 @@
                          individual preferred languages.
 
   Subtitle offset = 0    Allows you to shift the location of the subtitles in the
-                         vertical direction. The valid range is -50...50. This option
-                         is only avialable if "Display subtitles" is set to 'yes'.
+                         vertical direction. The valid range is -100...100. This option
+                         is only available if "Display subtitles" is set to 'yes'.
 
   Subtitle foreground transparency = 0
   Subtitle background transparency = 0
diff -ruN vdr-1.5.15/PLUGINS/src/skincurses/HISTORY vdr-1.5.16/PLUGINS/src/skincurses/HISTORY
--- vdr-1.5.15/PLUGINS/src/skincurses/HISTORY	2008-02-17 15:28:26.000000000 +0100
+++ vdr-1.5.16/PLUGINS/src/skincurses/HISTORY	2008-02-23 11:50:28.000000000 +0100
@@ -70,3 +70,8 @@
 
 - Using cString::sprintf() instead of asprintf().
 - Implemented cSkinCursesDisplayMenu::SetScrollbar().
+
+2008-02-23: Version 0.1.6
+
+- Revised the fix of calculating the scrollbar height in the skins. The scrollbar
+  handle now always has a height that is at least the width of the scrollbar.
diff -ruN vdr-1.5.15/PLUGINS/src/skincurses/skincurses.c vdr-1.5.16/PLUGINS/src/skincurses/skincurses.c
--- vdr-1.5.15/PLUGINS/src/skincurses/skincurses.c	2008-02-17 15:28:19.000000000 +0100
+++ vdr-1.5.16/PLUGINS/src/skincurses/skincurses.c	2008-02-23 11:38:04.000000000 +0100
@@ -3,7 +3,7 @@
  *
  * See the README file for copyright information and how to reach the author.
  *
- * $Id: skincurses.c 1.20 2008/02/17 14:28:19 kls Exp $
+ * $Id: skincurses.c 1.22 2008/02/23 10:38:04 kls Exp $
  */
 
 #include <ncurses.h>
@@ -11,7 +11,7 @@
 #include <vdr/plugin.h>
 #include <vdr/skins.h>
 
-static const char *VERSION        = "0.1.5";
+static const char *VERSION        = "0.1.6";
 static const char *DESCRIPTION    = trNOOP("A text only skin");
 static const char *MAINMENUENTRY  = NULL;
 
@@ -296,14 +296,15 @@
 {
   if (Total > 0 && Total > Shown) {
      int yt = Top;
-     int yb = yt + Height - 1;
+     int yb = yt + Height;
      int st = yt;
      int sb = yb;
-     int tt = st + (sb - st + 1) * Offset / Total;
-     int tb = tt + (sb - st + 1) * Shown / Total;
+     int th = max(int((sb - st) * double(Shown) / Total + 0.5), 1);
+     int tt = min(int(st + (sb - st) * double(Offset) / Total + 0.5), sb - th);
+     int tb = min(tt + th, sb);
      int xl = ScOsdWidth - 1;
-     osd->DrawRectangle(xl, st, xl, sb, clrWhite);
-     osd->DrawRectangle(xl, tt, xl, tb, clrCyan);
+     osd->DrawRectangle(xl, st, xl, sb - 1, clrWhite);
+     osd->DrawRectangle(xl, tt, xl, tb - 1, clrCyan);
      }
 }
 
diff -ruN vdr-1.5.15/config.h vdr-1.5.16/config.h
--- vdr-1.5.15/config.h	2008-02-05 16:35:11.000000000 +0100
+++ vdr-1.5.16/config.h	2008-02-17 17:04:52.000000000 +0100
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: config.h 1.305 2008/02/05 15:35:11 kls Exp $
+ * $Id: config.h 1.306 2008/02/17 16:04:52 kls Exp $
  */
 
 #ifndef __CONFIG_H
@@ -22,8 +22,8 @@
 
 // VDR's own version number:
 
-#define VDRVERSION  "1.5.15"
-#define VDRVERSNUM   10515  // Version * 10000 + Major * 100 + Minor
+#define VDRVERSION  "1.5.16"
+#define VDRVERSNUM   10516  // Version * 10000 + Major * 100 + Minor
 
 // The plugin API's version number:
 
diff -ruN vdr-1.5.15/device.c vdr-1.5.16/device.c
--- vdr-1.5.15/device.c	2008-02-16 14:52:11.000000000 +0100
+++ vdr-1.5.16/device.c	2008-02-23 14:09:01.000000000 +0100
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: device.c 1.153 2008/02/16 13:52:11 kls Exp $
+ * $Id: device.c 1.155 2008/02/23 13:09:01 kls Exp $
  */
 
 #include "device.h"
@@ -218,6 +218,7 @@
 int cDevice::currentChannel = 1;
 cDevice *cDevice::device[MAXDEVICES] = { NULL };
 cDevice *cDevice::primaryDevice = NULL;
+cDevice *cDevice::avoidDevice = NULL;
 
 cDevice::cDevice(void)
 {
@@ -356,6 +357,8 @@
 
 cDevice *cDevice::GetDevice(const cChannel *Channel, int Priority, bool LiveView)
 {
+  cDevice *AvoidDevice = avoidDevice;
+  avoidDevice = NULL;
   // Collect the current priorities of all CAM slots that can decrypt the channel:
   int NumCamSlots = CamSlots.Count();
   int SlotPriority[NumCamSlots];
@@ -385,6 +388,8 @@
       if (NumUsableSlots && SlotPriority[j] > MAXPRIORITY)
          continue; // there is no CAM available in this slot
       for (int i = 0; i < numDevices; i++) {
+          if (device[i] == AvoidDevice)
+             continue; // this device shall be temporarily avoided
           if (Channel->Ca() && Channel->Ca() <= CA_DVB_MAX && Channel->Ca() != device[i]->CardIndex() + 1)
              continue; // a specific card was requested, but not this one
           if (NumUsableSlots && !CamSlots.Get(j)->Assign(device[i], true))
@@ -1159,7 +1164,7 @@
 
 bool cDevice::Transferring(void) const
 {
-  return dynamic_cast<cTransfer *>(player) != NULL;
+  return ActualDevice() != PrimaryDevice();
 }
 
 bool cDevice::AttachPlayer(cPlayer *Player)
diff -ruN vdr-1.5.15/device.h vdr-1.5.16/device.h
--- vdr-1.5.15/device.h	2008-02-16 14:50:11.000000000 +0100
+++ vdr-1.5.16/device.h	2008-02-23 14:13:04.000000000 +0100
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: device.h 1.90 2008/02/16 13:50:11 kls Exp $
+ * $Id: device.h 1.91 2008/02/23 13:13:04 kls Exp $
  */
 
 #ifndef __DEVICE_H
@@ -101,6 +101,7 @@
   static int useDevice;
   static cDevice *device[MAXDEVICES];
   static cDevice *primaryDevice;
+  static cDevice *avoidDevice;
 public:
   static int NumDevices(void) { return numDevices; }
          ///< Returns the total number of devices.
@@ -145,6 +146,9 @@
          ///< this device/CAM combination will be skipped in the next call to
          ///< GetDevice().
          ///< See also ProvidesChannel().
+  static void SetAvoidDevice(cDevice *Device) { avoidDevice = Device; }
+         ///< Sets the given Device to be temporarily avoided in the next call to
+         ///< GetDevice(const cChannel, int, bool).
   static void Shutdown(void);
          ///< Closes down all devices.
          ///< Must be called at the end of the program.
